-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function MissionLauncher:StartActivity()
	print("MissionTut_08_02:StartActivity()!");

	if self.IsInitialized == nil then
		self.IsInitialized = false
	end
	
	if not self.IsInitialized then
		self.braindead = {};
		self.AssignedBrains = {};
		
		self.CPUTeam = Activity.TEAM_2;
		self.PlayerTeam = Activity.TEAM_1;
		self.RogueTeam = -1;
		
		self.TransferZone = SceneMan.Scene:GetArea("TUT8_TransferZone");
		
		for player = 0, self.PlayerCount - 1 do
			if not self:GetPlayerBrain(player) then
				self.braindead[player] = false;
				local brain = CreateAHuman("Brain Robot" , "base.rte");
				brain.Pos = Vector(150 + player * 30 , 550);
				brain.AIMode = Actor.AIMODE_SENTRY;
				self.AssignedBrains[player] = brain;

				MovableMan:AddActor(brain);
				self:SetPlayerBrain(brain, player);
				SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
				self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
				self:SwitchToActor(brain, player, self.PlayerTeam);
			end
		end	
		
		self.IsInitialized = true
	end
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function MissionLauncher:PauseActivity(pause)
    print("PAUSE! -- MissionTut_08_02:PauseActivity()!");
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function MissionLauncher:EndActivity()
    print("END! -- MissionTut_08_02:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function MissionLauncher:UpdateActivity()
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end
	
	if not self.IsInitialized then
		self:StartActivity()
	else
		self:DoBrainSelection();
	end

   	self:ClearObjectivePoints();

	self:AddObjectivePoint("Go to mission 1", Vector(792 , 500), self.PlayerTeam, GameActivity.ARROWDOWN);
	
	for actor in MovableMan.Actors do
		if  self.TransferZone:IsInside(actor.Pos) then
			SCENE_TO_LAUNCH = "MissionTut_08_01"
			SCRIPT_TO_LAUNCH = BASE_PATH.."MissionTut_08_01.lua"
			TRANSFER_IN_PROGRESS = true
			
			ActivityMan:EndActivity();
			ActivityMan:StartActivity("GAScripted" , "MissionTut_08");			
		
			break
		end
	end
	
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function MissionLauncher:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		-- print ("DoBrainSelection")
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
	
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					FrameMan:SetScreenText("Commander died!", player, 100, -1, false);
					self.braindead[player] = true;
					
					if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team);
						ActivityMan:EndActivity();
					end
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end --if
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------



































